<script setup lang="ts">
import type { VoteInformation } from '@/scripts/types'
import { reactive, onMounted } from 'vue'
import { useDataStore } from '@/store/data'
import { useRoute } from 'vue-router'
import API from '@/scripts/api'
import { useAppStore } from '@/store/app'

const data = useDataStore()
const app = useAppStore()
const route = useRoute()

const state = reactive({
  vote: undefined as VoteInformation | undefined,
  loading: false,
  titleModal: false
})
const typeModal = reactive({
  displayed: false,
  type: 'unique' as 'unique' | 'n-1'
})
const durationModal = reactive({
  displayed: false,
  duration: 60 // in seconds
})

onMounted(() => {
  const voteId = parseInt(route.params.id as string)
  state.vote = data.votes.find(v => v.id === voteId)
  data.refreshVotes().then(() => {
    state.vote = data.votes.find(v => v.id === voteId)
    if (state.vote == null) return
    if (state.vote.questions.length > 0) {
      typeModal.type = state.vote?.questions[0].max === 1 ? 'unique' : 'n-1'
    }
    durationModal.duration = state.vote ? Math.round(state.vote.duration / 1000) : 60
  })
})

function addQuestion () {
  if (state.vote == null) return
  state.vote.questions.push({
    question: '',
    min: 0,
    max: 0,
    options: ['']
  })
}

function removeQuestion (questionIndex: number) {
  if (state.vote == null) return
  state.vote.questions.splice(questionIndex, 1)
}

function removeOption (questionIndex: number, optionIndex?: number) {
  if (state.vote == null) return
  const optionsCount = state.vote?.questions[questionIndex].options.length
  return (optionsCount === 1)
    ? state.vote.questions.splice(questionIndex, 1)
    : state.vote?.questions[questionIndex].options.splice(optionIndex ?? optionsCount - 1, 1)
}

function saveVote () {
  if (state.vote == null) return
  state.loading = true
  state.vote.duration = durationModal.duration * 1000 // duration in ms

  for (const q of state.vote.questions) {
    // remove empty options
    q.options = q.options.filter(q => q.length > 0)

    const c = typeModal.type === 'n-1' ? q.options.length - 1 : 1
    q.min = c
    q.max = c
  }

  API.patchVote(state.vote?.id, state.vote).then(() => {
    app.notification('success', 'Vote enregistré !')
  }).finally(() => {
    state.loading = true
  })
}

function setQuestionToYesNoBlank(questionIndex: number) {
  if (state.vote == null || state.vote.questions[questionIndex] == null) return
  state.vote.questions[questionIndex].options = ['Oui', 'Blanc', 'Non']
}

function setQuestionToPositiveNegativeNeutral(questionIndex: number) {
  if (state.vote == null || state.vote.questions[questionIndex] == null) return
  state.vote.questions[questionIndex].options = ['Positif', 'Neutre', 'Négatif']
}
</script>

<template>
  <v-sheet rounded class="flex grow flex-col justify-center mx-auto max-w-4xl">
    <div v-if="state.vote" class="flex flex-col p-4">
      <div class="flex items-center">
        <h2 class="text-2xl my-4">#{{ state.vote.id }} - {{ state.vote.title }}</h2>
        <v-btn variant="text" class="mx-2" size="small" color="grey" round icon="mdi-pencil" @click="state.titleModal = true" />
        <div class="flex-grow" />
        <v-btn variant="outlined" class="mx-2" size="small" @click="typeModal.displayed = true">Type: {{ typeModal.type === 'unique' ? 'question unique' : 'N-1'}}</v-btn>
        <v-btn variant="outlined" class="mx-2" size="small" @click="durationModal.displayed = true">Durée: {{ durationModal.duration }}s</v-btn>
      </div>
      <div v-for="(question, questionIndex) of state.vote?.questions" v-bind:key="questionIndex" class="mb-4">
          <div class="flex">
            <v-text-field placeholder="Question" hide-details density="comfortable" v-model="question.question" :prefix="`Q${questionIndex + 1}`" append-icon="mdi-close" @click:append="removeQuestion(questionIndex)" />
          </div>
          <v-list lines="one">
            <v-list-item>
              <v-text-field
              hide-details
              placeholder="Option de réponse"
              append-icon="mdi-close"
              @click:append="removeOption(questionIndex, optionIndex)"
              class="m-2"
              density="compact"
              v-for="(option, optionIndex) in question.options"
              v-bind:key="optionIndex"
              v-model="question.options[optionIndex]" />
            </v-list-item>
          </v-list>
          <v-sheet class="ml-4 mb-4">
            <v-btn class="mx-2" variant="tonal" prepend-icon="mdi-plus" @click="question.options.push('')" >Option</v-btn>
            <v-btn class="mx-2" variant="tonal" prepend-icon="mdi-creation" @click="setQuestionToYesNoBlank(questionIndex)">Oui/Blanc/Non</v-btn>
            <v-btn class="mx-2" variant="tonal" prepend-icon="mdi-creation" @click="setQuestionToPositiveNegativeNeutral(questionIndex)">Positif/Neutre/Négatif</v-btn>
          </v-sheet>
        </div>
        <div class="flex">
          <v-btn variant="tonal" class="m-4" link to="/votes/management">Retour</v-btn>
          <div class="flex-grow" />
          <v-btn variant="tonal" color="primary" class="m-4" @click="addQuestion">Ajouter une question</v-btn>
          <v-btn variant="tonal" color="success" class="m-4" @click="saveVote">Enregistrer</v-btn>
        </div>
    </div>
    <div v-else class="flex flex-col items-center p-4">
      <h2 class="text-xl">Vote introuvable</h2>
      <div>
        <v-btn link to="/votes/management">Retour à la liste</v-btn>
      </div>
    </div>

    <v-dialog v-model="typeModal.displayed" max-width="500px">
      <v-card>
        <v-card-title>
          <span class="text-h5">Changement du type de vote</span>
        </v-card-title>

        <v-card-text>
          <!-- <v-select :items="[{title: 'Réponse unique', value: 'unique'}, {title: 'N-1', value: 'n-1'}]" v-model="typeModal.type" /> -->
          <div class="flex justify-evenly">
            <v-btn :active="typeModal.type === 'n-1'" @click="() => {typeModal.type = 'n-1'; typeModal.displayed = false}">N-1</v-btn>
            <v-btn :active="typeModal.type === 'unique'" @click="() => {typeModal.type = 'unique'; typeModal.displayed = false}">Option unique</v-btn>
          </div>
        </v-card-text>

        <v-card-actions>
          <div class="flex-grow" />
          <v-btn variant="text" @click="() => typeModal.displayed = false">
            Fermer
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>

    <v-dialog v-model="durationModal.displayed" max-width="500px">
      <v-card>
        <v-card-title>
          <span class="text-h5">Changement de la durée du vote</span>
        </v-card-title>

        <v-card-text>
          <v-text-field type="number" v-model.number="durationModal.duration" suffix="secondes" />
          <div class="flex justify-evenly">
            <v-btn :active="durationModal.duration === 120" @click="() => {durationModal.duration = 120; durationModal.displayed = false}">2 mins</v-btn>
            <v-btn :active="durationModal.duration === 180" @click="() => {durationModal.duration = 180; durationModal.displayed = false}">3 mins</v-btn>
            <v-btn :active="durationModal.duration === 300" @click="() => {durationModal.duration = 300; durationModal.displayed = false}">5 mins</v-btn>
          </div>
        </v-card-text>

        <v-card-actions>
          <div class="flex-grow" />
          <v-btn variant="text" @click="() => durationModal.displayed = false">
            Fermer
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>

    <v-dialog v-model="state.titleModal" max-width="500px">
      <v-card>
        <v-card-title>
          <span class="text-h5">Changer le titre du vote</span>
        </v-card-title>

        <v-card-text>
          <v-text-field v-if="state.vote" placeholder="Titre du vote" v-model="state.vote.title" />
        </v-card-text>

        <v-card-actions>
          <div class="flex-grow" />
          <v-btn :disabled="state.vote?.title.length === 0" variant="text" @click="() => state.titleModal = false">
            Fermer
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>

  </v-sheet>
</template>
